
#include <vector>
#include <iostream>
using namespace std;

#include <stdlib.h>
#include <time.h>

#define MAX 5

void sementear()
{
    time_t t;                   // https://pt.wikipedia.org/wiki/Time_t
    srand((unsigned) time(&t)); // Para funo srand e rand vide: https://www.tutorialspoint.com/c_standard_library/c_function_srand.htm
}

// o conjunto de msgs  apenas para se testar a execuo, assim no precisariam estar na resposta de prova.

namespace Mitologico
{
class Mito
{
    private:
        static int cont;
        short int id;

    protected:
        bool vivo;

    protected:
        void informar() const
        {
            cout << "O id de " << this << " eh: " << id << endl;
        }

    public:

        Mito(const bool v = true) : id (cont++), vivo(v)
        {
            sementear();
        }

        virtual ~Mito()
        {
            //cout << "Rodando a destrutora de Mito para: " << this << endl;
            vivo = false;
        }

        const int getId() const { return id; }

        void setVivo(const bool v) { vivo = v; }
        const bool getVivo() const { return vivo; }

        virtual void lutar(Mito* pm) = 0;
};
int Mito::cont(0);

class Godzilla : public Mito
{
    private:
        short int idade;
        short int irritado;

    public:

        Godzilla(const bool v = true):
            Mito(v),
            idade(rand()%1000), // (350),
            irritado(1000-idade) //(150)
        {
            sementear();
        }

        virtual ~Godzilla()
        {
            //cout << "Rodando a destrutora de Gozilla para: " << this << endl;
            idade = -1;
            irritado = -1;
        }

        const int getIdade() const    { return idade;    }
        const int getIrritado() const { return irritado; }

        void lutar(Mito* pm)
        {
            cout << "Lutar de Godzilla " << this << endl;
            informar(); // usado aqui por bom senso.

            if (pm)
            {
                pm->lutar(this);
            }
            else
            {
                cout << "Ponteiro nulo na chamada de Godzilla::lutar(Mito* pm)!" << endl;
            }
        }
};

class Alado : public Godzilla
{
    private:
        bool idoso;

    public:

        Alado(const bool v = true) :
            Godzilla (v),
            idoso( getIdade() > 700 )
        {
            sementear();
        }
        ~Alado()
        {
            //cout << "Rodando a destrutora de Alado para: " << this << endl;
        }

        void lutar(Mito* pm)
        {
            cout << "Lutar de Alado " << endl;
            if (!idoso)
            {
                Godzilla::lutar(pm);
            }
        }

        const bool operator>(Godzilla& gz) const
        {
            return getIdade() > gz.getIdade();
        }
};

class KingKong : public Mito
{
    private:
        static vector<KingKong*> kks;
        bool lider;

    public:

        KingKong(const bool v = true):
            Mito(v),
            lider(kks.empty())
        {

            sementear();
            if (vivo) considerar(this);

        }

        virtual ~KingKong()
        {
            //cout << "Rodando a destrutora de KingKong para: " << this << endl;
        }

        void lutar(Mito* pm) // aqui h uma srie de msg q na execuo da prova no precisaria ou poderiam ser simplficadas
        {
            cout << "Lutar de KingKong " << endl;

            informar(); // usado aqui por bom senso.

            if (pm)
            {
                if (vivo)
                {
                    Godzilla* pG = NULL;
                    pG = static_cast<Godzilla*>(pm);

                    if (pG->getVivo())
                    {
                        if ( (pG->getIdade() < 500) && (pG->getIrritado()>100) )
                        {
                            int tam = (int)kks.size();
                            if ( tam < 3 ) // tam < = 2
                            {
                                //if (kks.empty()) return;

                                kks[0]->setVivo(false); //((bool)rand()%2);
                                if (kks[0]->getVivo())
                                {
                                    cout << "COMBATE - KingKong lider " << this << " ainda vido - id " << getId() << endl;
                                }
                                else
                                {
                                     cout << "COMBATE - KingKong lider " << this << " neutralizado - id " << getId() << endl;
                                }

                                for (int i = 1; i < tam; i++)
                                {
                                    kks[i]->setVivo(false);
                                    cout << "COMBATE - KingKong seguidor " << this << " neutralizado - id " << getId() << endl;
                                }

                                vector<KingKong*>::iterator it;
                                it = kks.begin();
                                while (it != kks.end())
                                {
                                    if (false == (*it)->getVivo())
                                    {
                                        cout << "APS COMBATE - tirando de KKS o KingKing " << *it << "de Id: " << (*it)->getId() << endl;
                                        kks.erase(it);
                                        //system("Pause");
                                    }
                                    else
                                    {
                                        it++;
                                    }
                                }
                            }
                            else // if (TAM >= 2
                            {
                                pG->setVivo(false);
                                cout << "COMBATE - Godzila " << this << " neutralizado - id " << pG->getId() << endl;
                            }

                        }
                        else
                        {
                            cout    << "Sem combate entre o Godzilla " << this << " id "
                                    << pG->getId()
                                    << " e KingKong " << this << " id "
                                    << getId() << "." << endl;
                        }

                    }
                    else
                    {
                        cout << "Godzilla " << pG << " no vivo - id " << pG->getId() << endl;

                    }
                }
                else
                {
                    cout << "Este KingKong " << this << " est sem vida - id " << getId() << endl;
                }
            }
            else
            {
                cout << "Ponteiro de Godzilla nulo" << endl;
            }
        }

        static void considerar(KingKong* pk)
        {
            if (pk) kks.push_back(pk);
            else cout << "Ponteiro nulo de KingKong." << endl;
        }

};

vector<KingKong*> KingKong::kks;


class Ilha
{
    private:
        Godzilla    g;
        Alado       a;
        KingKong*   pkings[5];

    private:

        void criarKings(const short int x)
        {
            for (int i = 0; i < MAX; i++)
            {
                if ( (rand()%100) < x )
                {
                    pkings[i] = new KingKong();
                }
            }
        }

    public:
        Ilha(const short int x = 50): g(), a(), pkings()
        {
            for (int i = 0; i < MAX; i++)
            {
                 pkings[i] = NULL;
            }

            criarKings(x);
        }

        ~Ilha()
        {
            for (int i = 0; i < MAX; i++)
            {
                if (pkings[i])
                {
                    delete pkings[i];
                    pkings[i] = NULL;
                }
            }
        }

        void combater()
        {
            for (int i = 0; i < MAX; i++)
            {
                if (pkings[i])
                {
                    g.lutar(static_cast<Mito*>(pkings[i]));
                    a.lutar(static_cast<Mito*>(pkings[i]));
                }
            }

            a.operator>(g) ? cout << "a > g" : cout << "a <= g";
            cout << endl;
        }
};
} using namespace Mitologico;

int main()
{
    sementear();

    Ilha perdida(70);

    perdida.combater();

    return 0;
}
